﻿using System;
using System.Linq.Expressions;
using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MachinaAurum.ExtensionsMethods.Tests
{
    public class ClassWithEvent
    {
        public event EventHandler SomeEvent;

        public EventInfo GetEventInfo ()
        {
            return ByReflection.Event((ClassWithEvent x) => x.SomeEvent);
        }
    }

    [TestClass()]
    public class ByReflectionTest
    {
        public void EventTestHelper<TItem, TEvent>()
        {
            Expression<Func<TItem, TEvent>> func = null; // TODO: Initialize to an appropriate value
            MemberInfo expected = null; // TODO: Initialize to an appropriate value
            MemberInfo actual;
            actual = ByReflection.Event<TItem, TEvent>(func);
            Assert.AreEqual(expected, actual);
            Assert.Inconclusive("Verify the correctness of this test method.");
        }

        [TestMethod()]
        public void ByReflectionMustGetEventInfoByLambdExpression()
        {
            var obj = new ClassWithEvent();
            var eventInfo = obj.GetEventInfo();

            Assert.IsInstanceOfType(eventInfo, typeof(EventInfo));
            Assert.AreEqual("SomeEvent", eventInfo.Name);
        }
    }
}
