﻿using System.IO;
using System.Text;

public static class StreamExtensions
{
    public static string EncodeToString(this Stream stream)
    {
        return EncodeToString(stream, Encoding.Default);
    }

    public static string EncodeToString(this Stream stream, Encoding encoding, int bufferSize = 1024)
    {
        var buffer = new byte[bufferSize];
        int read = -1;
        int start = 0;

        StringBuilder builder = new StringBuilder();

        while (read != 0)
        {
            read = stream.Read(buffer, 0, buffer.Length);
            start += read;

            var str = encoding.GetString(buffer).Substring(0, read);
            builder.Append(str);
        }

        return builder.ToString();
    }
}
