﻿using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using Microsoft.Practices.ObjectBuilder2;

namespace MachinaAurum.Unity.Mef
{
    public class MefUnityBuildPlanStrategy : IBuilderStrategy
    {
        CompositionContainer Mef { get; set; }

        public MefUnityBuildPlanStrategy(CompositionContainer mef)
        {
            Mef = mef;
        }

        #region IBuilderStrategy Members

        public void PostBuildUp(IBuilderContext context)
        {
            if (context.Existing != null)
            {
                var aggCatalog = new AggregateCatalog();
                using (var child = new CompositionContainer(aggCatalog, Mef))
                {
                    child.SatisfyImportsOnce(context.Existing);
                }
            }
        }

        public void PostTearDown(IBuilderContext context)
        {
        }

        public void PreBuildUp(IBuilderContext context)
        {
        }

        public void PreTearDown(IBuilderContext context)
        {
        }

        #endregion
    }
}
