﻿using System.Collections.Generic;
using System.ComponentModel.Composition.Primitives;

namespace MachinaAurum.Unity.Mef
{
    public class UnityPartDefinition : ComposablePartDefinition
    {
        ComposablePartDefinition Part { get; set; }
        UnityAggregatedCatalog Catalog { get; set; }
        bool CreateFromUnity { get; set; }
        ExportDefinition Export { get; set; }

        public UnityPartDefinition(UnityAggregatedCatalog catalog, ComposablePartDefinition part)
        {
            Part = part;
            Catalog = catalog;
        }

        public UnityPartDefinition(UnityAggregatedCatalog catalog, ExportDefinition export)
        {
            Catalog = catalog;
            Export = export;
        }

        public override ComposablePart CreatePart()
        {
            if (Part != null)
            {
                return new UnityPart(Catalog, Part);
            }
            else
            {
                return new UnityPart(Catalog, Export);
            }
        }

        public override IEnumerable<ExportDefinition> ExportDefinitions
        {
            get { return Part.ExportDefinitions; }
        }

        public override IEnumerable<ImportDefinition> ImportDefinitions
        {
            get { return Part.ImportDefinitions; }
        }
    }
}
