﻿using MachinaAurum.Xna.Graphics.ContentTypeReaders;
using MachinaAurum.Xna.Graphics;

namespace MachinaAurum.Xna
{
    public static class Devices
    {
        public static IGraphicDevice Graphic { get; set; }

        public static IAurumModelReader ModelReader { get; set; }
        public static IAurumVertexBufferReader VertexBufferReader { get; set; }
        public static IAurumIndexBufferReader IndexBufferReader { get; set; }
        public static IAurumEffectReader EffectReader { get; set; }

        static Devices()
        {
            ModelReader = new AurumModelReader();
            VertexBufferReader = new DefaultAurumVertexBufferReader();
            IndexBufferReader = new AurumIndexBufferReader();
            EffectReader = new AurumEffectReader();
        }
    }
}
