﻿using Microsoft.Xna.Framework.Content;

namespace MachinaAurum.Xna.Graphics.ContentTypeReaders
{
    public class AurumIndexBufferReader : ContentTypeReader, IAurumIndexBufferReader
    {
        public AurumIndexBufferReader()
            : base(typeof(AurumIndexBuffer))
        {
        }

        protected override object Read(ContentReader input, object existingInstance)
        {
            int indexCount= 0;
            int indexSize = 0;

            bool indexIs16Bits = input.ReadBoolean();
            int num = input.ReadInt32();
            byte[] data = input.ReadBytes(num);

            if (indexIs16Bits)
            {
                indexCount = num / 2;
                indexSize = 16;
            }
            else
            {
                indexCount = num / 4;
                indexSize = 32;
            }

            var buffer = Devices.Graphic.CreateIndexBuffer(indexSize, indexCount);
            buffer.SetData(data);

            return buffer;
        }
    }
}
