﻿using Microsoft.Xna.Framework.Graphics;

namespace MachinaAurum.Xna.Graphics.ContentTypeReaders
{
    public class DefaultAurumVertexBufferReader : IAurumVertexBufferReader
    {
        #region IAurumVertexBufferReader Members

        public IAurumVertexBuffer Read(IStreamReader reader)
        {
            VertexDeclaration vertexDeclaration = reader.ReadRawObject<VertexDeclaration>();
            int vertexCount = reader.ReadInt32();
            int size = vertexCount * vertexDeclaration.VertexStride;
            byte[] data = reader.ReadBytes(size);

            var buffer = Devices.Graphic.CreateVertexBuffer(vertexDeclaration, vertexCount);
            buffer.SetData(data);
            return buffer;
        }

        #endregion
    }
}
