﻿
namespace MachinaAurum.Xna.Graphics.Effects
{
    public class BasicEffect : IEffectCode
    {
        private static string Code = @"
            matrix World;
            matrix View;
            matrix Projection;



            struct PS_INPUT
            {
	            float4 Pos : SV_POSITION;
                float3 Normal : Normal;
	            float4 Color : COLOR0;
            };

            PS_INPUT VS( float3 position : POSITION, float3 normal : NORMAL )
            {
	            PS_INPUT psInput;

                

	            float4x4 worldViewProj = mul(mul(World, View), Projection);
	            psInput.Pos = mul( float4(position,1), worldViewProj);
                psInput.Normal = normalize ( position );
	            psInput.Color = normalize ( psInput.Pos );

                return psInput;
            }

            float4 PS( PS_INPUT psInput ) : SV_Target
            {
                float3 l = { -1, 0, 0 };

                return psInput.Color;
            }

            technique10 Render
            {
                pass P0
                {
                    SetVertexShader( CompileShader( vs_4_0, VS() ) );
                    SetGeometryShader( NULL );
                    SetPixelShader( CompileShader( ps_4_0, PS() ) );
                }
            }
        ";

        #region IEffectCode Members

        string IEffectCode.Code
        {
            get { return BasicEffect.Code; }
        }

        #endregion
    }
}
