﻿using System.Collections.Generic;
using Microsoft.Xna.Framework;

namespace MachinaAurum.Xna.Graphics
{
    public class AurumModelBone : IAurumModelBone
    {
        public int Index { get; private set; }
        public string Name { get; private set; }
        
        public Matrix Transform { get; set; }

        public IAurumModelBone Parent { get; private set; }
        public IEnumerable<IAurumModelBone> Children { get; private set; }

        public AurumModelBone(string name, Matrix transform, int index)
        {
            Name = name;
            Transform = transform;
            Index = index;
        }

        public void SetParentAndChildren(IAurumModelBone newParent, IEnumerable<IAurumModelBone> newChildren)
        {
            Parent = newParent;
            Children = newChildren;
        }
    }
}
