﻿using System;
using MachinaAurum.Xna.Graphics.Effects;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MachinaAurum.Xna.Graphics
{
    public interface IGraphicDevice : IDisposable
    {
        void Create( Game game );

        IAurumVertexBuffer CreateVertexBuffer(VertexDeclaration vertexDeclaration, int vertexCount);
        IAurumIndexBuffer CreateIndexBuffer(int indexSize, int indexCount);
        IAurumEffect CreateEffect(IEffectCode code);

        void Clear(Color color);
        void Present();

        void DrawUserPrimitives<T>(PrimitiveType primitiveType, T[] data, int offset, int primitiveCount, IAurumEffect effect);
    }
}
