﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using MachinaAurum.WebServer;
using Microsoft.Practices.Unity;

namespace MachinaAurum.Xna.Console
{
    public class ServiceManager : IDisposable
    {
        ServiceHost ConsoleHost;

        [Dependency("BuildUp")]
        public Action<object> BuildUp { get; set; }

        public ServiceManager( )
        {
        }

        public void StartWebServer()
        {
            WebServerService service = new WebServerService();
            BuildUp(service);

            var uri = new Uri(string.Format("http://{0}:{1}/", Environment.MachineName, 8080));
            ConsoleHost = new ServiceHost(service, uri);

            var binding = new WebHttpBinding();

            var end1 = ConsoleHost.AddServiceEndpoint(typeof(IWebServerService), binding, "Console");
            end1.Behaviors.Add(new WebHttpBehavior());

            var sdb = ConsoleHost.Description.Behaviors.Find<ServiceDebugBehavior>();
            sdb.HttpHelpPageEnabled = false;

            ConsoleHost.Open();
        }

        #region IDisposable Members

        public void Dispose()
        {
            ConsoleHost.Close();
        }

        #endregion
    }
}
