﻿using System.IO;
using MachinaAurum.WebServer;
using Microsoft.Xna.Framework;
using System.Collections.Generic;

namespace MachinaAurum.Xna.WebControllers
{
    public class SystemViewModel
    {
        public string Name { get; set; }
    }

    public class MainViewModel
    {
        public IEnumerable<SystemViewModel> Systems { get; set; }
    }

    [Controller(Name = "Main")]
    public class MainController : BaseController
    {
        Game Game;
        public MainController(Game game)
        {
            Game = game;
        }

        public Stream Main()
        {
            dynamic template = Engine.GetTemplate("main.cshtml");
            template.ViewModel = new MainViewModel()
            {
                Systems = new SystemViewModel[]
                {
                    new SystemViewModel(){Name = "Console"}
                }
            };

            //Game.Services.GetService(typeof(IConsoleService))

            return GenerateHtml(template);
        }
    }
}
