﻿
using System.IO;
using System.ServiceModel.Web;
using MachinaAurum.TemplateEngine;
using Microsoft.Practices.Unity;

namespace MachinaAurum.WebServer
{
    public class BaseController : IController
    {
        [Dependency]
        public ITemplateEngine Engine { get; set; }

        protected Stream GenerateHtml(dynamic template)
        {
            template.Execute();

            WebOperationContext.Current.OutgoingResponse.ContentType = "text/html";
            var encoding = WebOperationContext.Current.OutgoingResponse.BindingWriteEncoding;

            string result = template.ToString();
            return result.ToBytes(encoding).ToStream();
        }
    }
}
