﻿using System;
using System.Collections.Generic;

namespace MachinaAurum.Unity.Aspect
{
    [AttributeUsage(AttributeTargets.All, Inherited = false, AllowMultiple = true)]
    public class InjectAttribute : Attribute
    {
        public int Order { get; set; }
        public Type Injection { get; set; }
        public IDictionary<string, object> Parameters { get; private set; }
        public string [] Rules { get; set; }

        public InjectAttribute()
        {
            Parameters = new Dictionary<string, object>();
            Rules = new string[] { "(.)*" };
        }
    }
}
